local mod = ...



-- Villager need -------------------------------------------------------------------------------------
-- This need is created in Common Resources mod, but activated here
mod:overrideAsset({
    Id = "COMMONER",
    AssetVillagerNeedList = {
        Action = "APPEND", "NEED_SERVANT",
    }
})



-- Building Function: Household Servant -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "JOB",
	Id = "JOB_SERVANT",
	JobName = "JOB_SERVANT_NAME",
	JobDescription = "JOB_SERVANT_DESC",
	IsLockedByDefault = true,
	-- DefaultBehavior = "BEHAVIOR_SERVANT",
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 120.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
})

mod:overrideAsset({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SERVANT"
    }
})

mod:overrideAsset({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_SERVANT"
    }
})

mod:registerAsset({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_SERVANT1",
    Name = "BUILDING_FUNCTION_SERVANT_NAME",
    WorkerCapacity = 1,
    RelatedJob = {
        Job = "JOB_SERVANT",
        -- Behavior = "BEHAVIOR_SERVANT"
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "RESOURCE_TYPE_SERVANT" },
    CapacityMultiplier = 1,
    UpkeepPerWorker = {
        {
            Resource = "GOLD_COINS",
            Quantity = 1,
        },
    },
	-- IsOverrideCapacity = true,
	-- CapacityPerSlot = 2,
    -- IsPrivate = true,
    -- HasResourceDepot = false,
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
    ResourceProduced = {
		{ Resource = "RESOURCE_SERVANT", Quantity = 1 },
	}
})

mod:registerAsset({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_SERVANT3",
    Name = "BUILDING_FUNCTION_SERVANT_NAME",
    WorkerCapacity = 3,
    RelatedJob = {
        Job = "JOB_SERVANT",
        -- Behavior = "BEHAVIOR_SERVANT"
        Behavior = "BEHAVIOR_WORK"
    },
	TypeList = { "RESOURCE_TYPE_SERVANT" },
    CapacityMultiplier = 1,
    UpkeepPerWorker = {
        {
            Resource = "GOLD_COINS",
            Quantity = 1,
        },
    },
	-- IsOverrideCapacity = true,
	-- CapacityPerSlot = 6,
    -- IsPrivate = true,
    -- HasResourceDepot = false,
    InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
    ResourceProduced = {
		{ Resource = "RESOURCE_SERVANT", Quantity = 1 },
	}
})

-- mod:registerAsset({
--     DataType = "BUILDING_FUNCTION_WORKPLACE",
--     Id = "BUILDING_FUNCTION_SERVANT2",
--     Name = "BUILDING_FUNCTION_SERVANT_NAME",
--     WorkerCapacity = 2,
--     RelatedJob = { 
--         Job = "JOB_SERVANT",
--         Behavior = "BEHAVIOR_SERVANT"
--     },
--     InputInventoryCapacity = {
-- 	},
--     ResourceListNeeded = {
-- 	},
--     ResourceProduced = {
-- 		-- { Resource = "RESOURCE_SERVANT", Quantity = 1 },
-- 	}
-- })

-- mod:registerAsset({
--     DataType = "BUILDING_FUNCTION_WORKPLACE",
--     Id = "BUILDING_FUNCTION_SERVANT6",
--     Name = "BUILDING_FUNCTION_SERVANT_NAME",
--     WorkerCapacity = 6,
--     RelatedJob = {
--         Job = "JOB_SERVANT",
--         Behavior = "BEHAVIOR_SERVANT"
--     },
--     InputInventoryCapacity = {
-- 	},
--     ResourceListNeeded = {
-- 	},
--     ResourceProduced = {
-- 		-- { Resource = "RESOURCE_SERVANT", Quantity = 1 },
-- 	}
-- })



-- Give commoner and citizen houses the building function -------------------------------------------------------------------------------------
mod:overrideAsset({
    Id = "BUILDING_PART_HOUSING_CITIZEN_DENSITY_1",
    AssetBuildingFunction = "BUILDING_FUNCTION_SERVANT1",
})

mod:overrideAsset({
    Id = "BUILDING_PART_HOUSING_CITIZEN_DENSITY_2",
    AssetBuildingFunction = "BUILDING_FUNCTION_SERVANT3",
})

